import { Icon } from '@chakra-ui/react';
import { ChangeEvent } from 'react';

import * as constants from '../../constants';

import './style.scss';

type Props = {
  isChecked?: boolean;
  onChange?: (event: ChangeEvent<HTMLInputElement>) => void;
};

function Checkbox(props: Props) {
  const {
    isChecked,
    onChange: handleChange,
  } = props;

  return (
    <>
      <input
        type="checkbox"
        className="checkbox"
        checked={isChecked}
        style={{ cursor: 'pointer' }}
        onChange={handleChange ? (event) => handleChange(event) : undefined}
      />
      <Icon
        color={isChecked ? constants.GRAY_400 : constants.GRAY_800}
        viewBox="0 0 16 16"

        // Chakra UI sets this as inline-block by default, which was not positioning the SVG
        // correctly.
        display="block"
      >
        <path
          className="border"
          d="M13.3333 0H2.66667C1.95942 0 1.28115 0.280952 0.781049 0.781049C0.280952 1.28115 0 1.95942 0 2.66667V13.3333C0 14.0406 0.280952 14.7189 0.781049 15.219C1.28115 15.719 1.95942 16 2.66667 16H13.3333C14.0406 16 14.7189 15.719 15.219 15.219C15.719 14.7189 16 14.0406 16 13.3333V2.66667C16 1.95942 15.719 1.28115 15.219 0.781049C14.7189 0.280952 14.0406 0 13.3333 0ZM14.2222 13.3333C14.2222 13.5691 14.1286 13.7952 13.9619 13.9619C13.7952 14.1286 13.5691 14.2222 13.3333 14.2222H2.66667C2.43092 14.2222 2.20483 14.1286 2.03813 13.9619C1.87143 13.7952 1.77778 13.5691 1.77778 13.3333V2.66667C1.77778 2.43092 1.87143 2.20483 2.03813 2.03813C2.20483 1.87143 2.43092 1.77778 2.66667 1.77778H13.3333C13.5691 1.77778 13.7952 1.87143 13.9619 2.03813C14.1286 2.20483 14.2222 2.43092 14.2222 2.66667V13.3333Z"
          fill="currentColor"
        />
        <path
          className="filled-checkbox"
          d="M2.66667 0H13.3333C14.0406 0 14.7189 0.280952 15.219 0.781049C15.719 1.28115 16 1.95942 16 2.66667V13.3333C16 14.0406 15.719 14.7189 15.219 15.219C14.7189 15.719 14.0406 16 13.3333 16H2.66667C1.95942 16 1.28115 15.719 0.781049 15.219C0.280952 14.7189 0 14.0406 0 13.3333V2.66667C0 1.95942 0.280952 1.28115 0.781049 0.781049C1.28115 0.280952 1.95942 0 2.66667 0Z"
          fill="none"
        />
        <path
          className="checkmark"
          d="M10.4 4.7911L7.04 9.23555L5.59111 7.35999C5.44612 7.17375 5.23309 7.05273 4.99888 7.02356C4.76467 6.99439 4.52846 7.05945 4.34222 7.20444C4.15598 7.34942 4.03496 7.56245 4.00579 7.79666C3.97662 8.03088 4.04168 8.26708 4.18667 8.45333L6.34667 11.2178C6.43037 11.3237 6.53712 11.4092 6.65879 11.4677C6.78046 11.5262 6.91387 11.5563 7.04889 11.5555C7.18464 11.5552 7.31851 11.5238 7.44023 11.4637C7.56196 11.4036 7.6683 11.3164 7.75111 11.2089L11.8133 5.87555C11.9571 5.68695 12.0201 5.44895 11.9885 5.2139C11.9568 4.97886 11.833 4.76602 11.6444 4.62221C11.4558 4.47841 11.2178 4.41541 10.9828 4.44709C10.7478 4.47876 10.5349 4.60251 10.3911 4.7911H10.4Z"
          fill="none"
        />
      </Icon>
    </>
  );
}

export default Checkbox;
